/*!
 * (C) PAQT.com B.V. https://paqt.com - MIT License
 */
import { proxyCustomElement, HTMLElement, h, Host } from '@stencil/core/internal/client';

const menuDividerCss = ".gr-scroll-lock{overflow:hidden !important}:host{--margin-top:var(--gr-spacing-x-small);--margin-bottom:var(--gr-spacing-x-small);--border-color:var(--gr-panel-border-color);display:block;box-sizing:border-box}:host *,:host *:before,:host *:after{box-sizing:inherit}.menu-divider{border-top:solid 1px var(--border-color);margin-top:var(--margin-top);margin-left:0;margin-right:0;margin-bottom:var(--margin-bottom)}";

const MenuDivider = /*@__PURE__*/ proxyCustomElement(class extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this.__attachShadow();
  }
  render() {
    return (h(Host, null, h("div", { class: "menu-divider", role: "separator", "aria-hidden": "true" })));
  }
  static get style() { return menuDividerCss; }
}, [1, "gr-menu-divider"]);
function defineCustomElement$1() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["gr-menu-divider"];
  components.forEach(tagName => { switch (tagName) {
    case "gr-menu-divider":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, MenuDivider);
      }
      break;
  } });
}
defineCustomElement$1();

const GrMenuDivider = MenuDivider;
const defineCustomElement = defineCustomElement$1;

export { GrMenuDivider, defineCustomElement };

//# sourceMappingURL=gr-menu-divider.js.map