/*!
 * (C) PAQT.com B.V. https://paqt.com - MIT License
 */
import { proxyCustomElement, HTMLElement, h, Host } from '@stencil/core/internal/client';

const menuLabelCss = ".gr-scroll-lock{overflow:hidden !important}:host{--font-style:normal;--font-weight:var(--gr-font-weight-normal);--line-height:var(--gr-line-height-normal);--background-color:transparent;--color:var(--gr-color-medium-tint);--padding-top:var(--gr-spacing-xx-small);--padding-start:var(--gr-spacing-x-large);--padding-end:var(--gr-spacing-x-large);--padding-bottom:var(--gr-spacing-xx-small);display:block;font-family:var(--gr-font-family);font-size:var(--gr-font-size-small);font-weight:var(--font-weight);font-style:var(--font-style);line-height:var(--line-height);letter-spacing:var(--gr-letter-spacing-normal);color:var(--color);padding-top:var(--padding-top);padding-left:var(--padding-start);padding-right:var(--padding-end);padding-bottom:var(--padding-bottom);user-select:none;text-align:left;box-sizing:border-box}:host *,:host *:before,:host *:after{box-sizing:inherit}";

const MenuLabel = /*@__PURE__*/ proxyCustomElement(class extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this.__attachShadow();
  }
  render() {
    return (h(Host, null, h("slot", null)));
  }
  static get style() { return menuLabelCss; }
}, [1, "gr-menu-label"]);
function defineCustomElement$1() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["gr-menu-label"];
  components.forEach(tagName => { switch (tagName) {
    case "gr-menu-label":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, MenuLabel);
      }
      break;
  } });
}
defineCustomElement$1();

const GrMenuLabel = MenuLabel;
const defineCustomElement = defineCustomElement$1;

export { GrMenuLabel, defineCustomElement };

//# sourceMappingURL=gr-menu-label.js.map