/*!
 * (C) PAQT.com B.V. https://paqt.com - MIT License
 */
import { proxyCustomElement, HTMLElement, h } from '@stencil/core/internal/client';

const tabPanelCss = ":host{--padding:0;display:block}.tab-panel{border:solid 1px transparent;padding:var(--padding)}";

const TabPanel = /*@__PURE__*/ proxyCustomElement(class extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this.__attachShadow();
    this.name = '';
    this.active = false;
  }
  render() {
    const { active } = this;
    this.el.style.display = this.active ? 'block' : 'none';
    return (h("div", { part: "base", class: "tab-panel", role: "tabpanel", "aria-hidden": active ? 'false' : 'true' }, h("slot", null)));
  }
  get el() { return this; }
  static get style() { return tabPanelCss; }
}, [1, "gr-tab-panel", {
    "name": [513],
    "active": [516]
  }]);
function defineCustomElement$1() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["gr-tab-panel"];
  components.forEach(tagName => { switch (tagName) {
    case "gr-tab-panel":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, TabPanel);
      }
      break;
  } });
}
defineCustomElement$1();

const GrTabPanel = TabPanel;
const defineCustomElement = defineCustomElement$1;

export { GrTabPanel, defineCustomElement };

//# sourceMappingURL=gr-tab-panel.js.map