/* core custom elements */
export { Button as GrButton } from '../dist/types/components/button/button';
export { Checkbox as GrCheckbox } from '../dist/types/components/checkbox/checkbox';
export { DatePicker as GrDatePicker } from '../dist/types/components/date-picker/date-picker';
export { Dropdown as GrDropdown } from '../dist/types/components/dropdown/dropdown';
export { FieldGroup as GrFieldGroup } from '../dist/types/components/field-group/field-group';
export { Input as GrInput } from '../dist/types/components/input/input';
export { Menu as GrMenu } from '../dist/types/components/menu/menu';
export { MenuDivider as GrMenuDivider } from '../dist/types/components/menu-divider/menu-divider';
export { MenuItem as GrMenuItem } from '../dist/types/components/menu-item/menu-item';
export { MenuLabel as GrMenuLabel } from '../dist/types/components/menu-label/menu-label';
export { Radio as GrRadio } from '../dist/types/components/radio/radio';
export { RadioGroup as GrRadioGroup } from '../dist/types/components/radio-group/radio-group';
export { Select as GrSelect } from '../dist/types/components/select/select';
export { Spinner as GrSpinner } from '../dist/types/components/spinner/spinner';
export { Tab as GrTab } from '../dist/types/components/tab/tab';
export { TabGroup as GrTabGroup } from '../dist/types/components/tab-group/tab-group';
export { TabPanel as GrTabPanel } from '../dist/types/components/tab-panel/tab-panel';
export { Tag as GrTag } from '../dist/types/components/tag/tag';
export { Textarea as GrTextarea } from '../dist/types/components/textarea/textarea';

/**
 * Used to manually set the base path where assets can be found.
 * If the script is used as "module", it's recommended to use "import.meta.url",
 * such as "setAssetPath(import.meta.url)". Other options include
 * "setAssetPath(document.currentScript.src)", or using a bundler's replace plugin to
 * dynamically set the path at build time, such as "setAssetPath(process.env.ASSET_PATH)".
 * But do note that this configuration depends on how your script is bundled, or lack of
 * bundling, and where your assets can be loaded from. Additionally custom bundling
 * will have to ensure the static assets are copied to its build directory.
 */
export declare const setAssetPath: (path: string) => void;

export interface SetPlatformOptions {
  raf?: (c: FrameRequestCallback) => number;
  ael?: (el: EventTarget, eventName: string, listener: EventListenerOrEventListenerObject, options: boolean | AddEventListenerOptions) => void;
  rel?: (el: EventTarget, eventName: string, listener: EventListenerOrEventListenerObject, options: boolean | AddEventListenerOptions) => void;
}
export declare const setPlatformOptions: (opts: SetPlatformOptions) => void;
export * from '../dist/types';
